/********************************************************
 * Data Visualization - Final Project                   *
 * Global Warming and Marine Life Capture               *     
 *                                                      *
 * Author: Hilda Chang HE                               *
 * Date: March 2016                                     *
 *                                                      *
 * Purpose: Final project for MAT259A                   *
 *          3D data visualization                       *
 ********************************************************/
import peasy.*;
import controlP5.*;
import java.awt.*;
import java.util.*;
PeasyCam cam;
ControlP5 cp5;

boolean dataMode;
boolean showTitle;
boolean showLable;

Yield[] GCP;
SeaLevel[] sL;
GlobalTemprature gT;


Cluster gcp2, gcp3, gcp4, gcp6, gcp7;
TreeNode sl2, sl3, sl4, sl6, sl7, gt; 

void setup(){
    size(1024, 740, P3D);
    dataMode = false;
    showTitle = true;
    showLable = true;
    //smooth();
    loadData();
    //printData();
    //make shapes
    gcp2 = makeTree(GCP[2].marineF, GCP[2].crustacean, GCP[2].molluscs);
    gcp3 = makeTree(GCP[3].marineF, GCP[3].crustacean, GCP[3].molluscs);
    gcp4 = makeTree(GCP[4].marineF, GCP[4].crustacean, GCP[4].molluscs);
    gcp6 = makeTree(GCP[6].marineF, GCP[6].crustacean, GCP[6].molluscs);
    gcp7 = makeTree(GCP[7].marineF, GCP[7].crustacean, GCP[7].molluscs);
    
    sl2 = makeSingleTree(sL[2].seaLevel);
    sl3 = makeSingleTree(sL[3].seaLevel);
    sl4 = makeSingleTree(sL[4].seaLevel);
    sl6 = makeSingleTree(sL[6].seaLevel);
    sl7 = makeSingleTree(sL[7].seaLevel);
    
    gt = makeSingleTree(gT.temperature);
    
    println();
    
    cam = new PeasyCam(this, width/2, height/2 , 0 , 4000);
    cp5 = new ControlP5(this);
}
  
void draw(){
    if(dataMode == false){
      background(50);
      pushMatrix();
      translate(width/2, height/2, 0);
          {//Africa
            pushMatrix();
            translate(-100, 1000, 1000);
            drawTree(gcp2);
            popMatrix();
          }
          {//USA east
           pushMatrix();
           translate(-600, 1000, -500);
           drawTree(gcp3);
           popMatrix();
          }
          {//USA west
           pushMatrix();
           translate(-2000, 1000, -800);
           drawTree(gcp4);
           popMatrix();
          }
          {//Europe
           pushMatrix();
           translate(500, 1000, -1500);
           drawTree(gcp6);
           popMatrix();
          }
          {//Asia
           pushMatrix();
           translate(2000, 1000, 500);
           drawTree(gcp7);
           popMatrix();
          }
          //sea level
          {
           pushMatrix();
           translate(-100, -500, 1000);
           rotate(PI/3);
           drawSingleTree(sl2);
           popMatrix();
          }
          {//USA east
           pushMatrix();
           translate(-600, -500, -500);
           rotate(PI/3);
           drawSingleTree(sl3);
           popMatrix();
          }
          {//USA west
           pushMatrix();
           translate(-2000, -500, -800);
           rotate(PI/3);
           drawSingleTree(sl4);
           popMatrix();
          }
          {//Europe
           pushMatrix();
           translate(500, -500, -1500);
           rotate(PI/3);
           drawSingleTree(sl6);
           popMatrix();
          }
          {//Asia
           pushMatrix();
           translate(2000, -500, 500);
           rotate(PI/3);
           drawSingleTree(sl7);
           popMatrix();
          }
          {
           pushMatrix();
           translate(0, -1200, 000);
           rotate(-2*PI/3);
           drawSingleTreeGT(gt);
           popMatrix();
          }
      popMatrix();
      gui();
    }else{
      background(220);
      
      pushMatrix();
      translate(0,0,3250);
      drawGCPSketch();
      lable1();
      popMatrix();
      
      pushMatrix();
      translate(0,0,-3000);
      drawSLSketch();
      lable2();
      popMatrix();
      
    }
  
}