PVector center = new PVector(0,0,0);
//shape parameters:
int lengthRange = 80;
int lengthMin = 40;

//data range
int RANGE = 10;

void drawTree(Cluster shape){
    int a = 1020;
    //BFT algorithm to draw shape
    strokeWeight(1);
    
    if(shape == null)
        System.out.println("Empty cluster");
    else{
        //draw branck1
        stroke(255);
        line(center.x, center.y, center.z, 
             shape.root1.position.x, shape.root1.position.y, shape.root1.position.z);
        Queue<TreeNode> q1= new LinkedList<TreeNode>();
        q1.add(shape.root1);
        while(q1.peek() != null)
        {
            TreeNode temp = q1.remove();
            //println(temp.position.x);
            if(temp.left != null){
                a--;
                stroke(255,255,255,a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.left.position.x, temp.left.position.y, temp.left.position.z);
                q1.add(temp.left);
            }
            if(temp.right != null){
                stroke(255,255,255,a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.right.position.x, temp.right.position.y, temp.right.position.z);
                q1.add(temp.right); 
            }
        }
        //draw branch2
        a = 1020;
        stroke(140, 70 ,190);
        line(center.x, center.y, center.z, 
             shape.root2.position.x, shape.root2.position.y, shape.root2.position.z);
        Queue<TreeNode> q2= new LinkedList<TreeNode>();
        q2.add(shape.root2);
        while(q2.peek() != null)
        {
            TreeNode temp = q2.remove();
            //println(temp.position.x);
            if(temp.left != null){
                a--;
                stroke(140, 70 ,190, a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.left.position.x, temp.left.position.y, temp.left.position.z);
                q2.add(temp.left);
            }
            if(temp.right != null){
                stroke(140, 70 ,190, a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.right.position.x, temp.right.position.y, temp.right.position.z);
                q2.add(temp.right); 
            }
        }
        //draw branch3
        a = 1020;
        stroke(250, 120, 0);
        line(center.x, center.y, center.z, 
             shape.root3.position.x, shape.root3.position.y, shape.root3.position.z);
        Queue<TreeNode> q3= new LinkedList<TreeNode>();
        q3.add(shape.root3);
        while(q3.peek() != null)
        {
            TreeNode temp = q3.remove();
            //println(temp.position.x);
            if(temp.left != null){
                a--;
                stroke(250, 120, 0, a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.left.position.x, temp.left.position.y, temp.left.position.z);
                q3.add(temp.left);
            }
            if(temp.right != null){
                stroke(250, 120, 0, a/4);
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.right.position.x, temp.right.position.y, temp.right.position.z);
                q3.add(temp.right); 
            }
        }
    }  
}


Cluster makeTree(int[] dataSet1, int[] dataSet2, int[] dataSet3){ //parameter
    //get data ready
    //float[] data = {50, 60, 40, 50, 60, 90};
    //float[] extend = {0.9, 1.4, 1.0, 0.5, 1.1, 0.7};    
    float[] data1 = trimDataForShape(dataSet1);
    float[] extend1 = new float[data1.length];
    extend1[0] = 1;
    for(int i = 1; i<extend1.length; i++){
        extend1[i] = (float)data1[i]/ (5 * (float)data1[i-1]);
        //println(extend1[i]);
    }
    
    float[] data2 = trimDataForShape(dataSet2);
    float[] extend2 = new float[data1.length];
    extend2[0] = 1;
    for(int i = 1; i<extend2.length; i++){
        extend2[i] = (float)data2[i]/ (5 * (float)data2[i-1]);
        //println(extend2[i]);
    }
    
    float[] data3 = trimDataForShape(dataSet3);
    float[] extend3 = new float[data3.length];
    extend3[0] = 1;
    for(int i = 1; i<extend3.length; i++){
        extend3[i] = (float)data3[i]/ (5 * (float)data3[i-1]);
        //println(extend3[i]);
    }
    //println("Extend length: " + extend3.length);
    
    //make tree
    PVector[] roots = firstThree(data1[0]);
    Cluster shape = new Cluster(roots[0], roots[1], roots[2]);

    for(int i = 0; i<data1.length; i++){
        TreeNode root = new TreeNode(center);
        root.right = shape.root2; 
        addLayerQ(shape.root1, root, data1[i], extend1[i]);
        root.right = shape.root3;
        addLayerQ(shape.root2, root, data2[i], extend2[i]);
        root.right = shape.root1;
        addLayerQ(shape.root3, root, data3[i], extend3[i]);
    }
    
    //println("finish make tree;");
    return shape;
}

void addLayerQ(TreeNode root, TreeNode pRoot, float data, float extend){
    if(root == null)
        System.out.println("Empty tree");
    else{
        Queue<TreeNode> q= new LinkedList<TreeNode>();
        Queue<TreeNode> p= new LinkedList<TreeNode>();
        q.add(root);
        p.add(pRoot);
        while(q.peek() != null)
        {
            TreeNode temp = q.remove();
            TreeNode parent = p.remove();
            //System.out.println(temp.getData());
            if(temp.left != null)
                q.add(temp.left);
                p.add(temp);
            if(temp.right != null)
                q.add(temp.right);
                p.add(temp);
            if(temp.left == null){
                //add node 
                //println("make new leaves");
                if(parent.right != temp){
                    temp.left = new TreeNode(nextPositive(data, extend, 
                                             temp.position, parent.position, parent.right.position));
                    //println(temp.left.position.x);
                    temp.right = new TreeNode(nextNegative(data, extend, 
                                              temp.position, parent.position, parent.right.position));
                    //println(temp.right.position.x);
                }else{
                    temp.left = new TreeNode(nextPositive(data, extend, 
                                             temp.position, parent.position, parent.left.position));
                    //println(temp.left.position.x);
                    temp.right = new TreeNode(nextNegative(data, extend, 
                                              temp.position, parent.position, parent.left.position));
                    //println(temp.right.position.x);
                }
            }
        }
    }
}


float[] trimDataForShape(int[] rawData){
  //trim data
  int[] usefulData =new int[RANGE];
  for(int i = 0; i < usefulData.length; i++){
    usefulData[i] = rawData[i+(rawData.length - RANGE)]; 
  }
  
  float[] data = new float[RANGE];
  float min = min(usefulData);
  float max = max(usefulData);
  
  //GCP
  if(rawData.length == DURATION){
    min = max;
    for(int i = 0; i < usefulData.length; i++){
      if(usefulData[i] < min && usefulData[i] != 0) min = usefulData[i];
    }

    for(int i = 0 ; i < usefulData.length; i++){
        int rawDatai = usefulData[i];
        if(rawDatai == 0) rawDatai = (int)min;
        data[i] = sqrt(sqrt(rawDatai)) * 2;
        //data[i] = (int)map(rawDatai, min, max, lengthMin, lengthMin+ lengthRange); 
      }

  }else 
  //sL or gT
  if(rawData.length == YEAR){
    //sL
    if(max>1000){
      println("in trim data for sL");
      for(int i = 0; i < usefulData.length; i++){
        data[i] = (int)map(usefulData[i], min, max, lengthMin, lengthMin+ lengthRange)/1.5; 
        //data[i] = (int)sqrt(sqrt(usefulData[i])) *;
        println(data[i]);
      }
    }else{ //gT
      for(int i = 0; i < usefulData.length; i++){
        data[i] = (int)map(usefulData[i], min, max, lengthMin, lengthMin+ lengthRange); 
      }
    }  
  }
  return data;
}


PVector[] firstThree(float len){
    PVector[] first3 = new PVector[3];
    //center=(0,0,0);
    first3[0] = new PVector(len*cos(PI/6), len*sin(PI/6), 10);
    first3[1] = new PVector(-len*cos(PI/6), len*sin(PI/6), 0);
    first3[2] = new PVector(0, -len, -10);
    return first3;
}

//TODO: clean comments
PVector nextPositive(float len, float extend, PVector start, PVector parent, PVector sibling){
    //println("input parameters: " + len + " " + extend);
  
    PVector node;
    //do cross product to calculate vertical
    PVector PS = v_sub(parent,start);
    
    //println("PS: " + PS.x + " " + PS.y + " " + PS.z);
    
    PVector vertical = v_cross(PS, v_sub(parent,sibling));
    node = v_add(v_mul(v_dir(vertical), len), start);
    //extend
    node = v_add(v_add(v_sub(start, node), v_mul(v_dir(v_sub(start,center)), extend * v_len(PS))), start);

    //println("next node: " + node.x + " " + node.y+ " " + node.z);
    return node;
}

PVector nextNegative(float len, float extend, PVector start, PVector parent, PVector sibling){
    PVector node;
    //do cross product to calculate vertical
    PVector PS = v_sub(parent,start);
    PVector vertical = v_cross(v_sub(parent,sibling), PS);
    node = v_add(v_mul(v_dir(vertical), len), start);
    //extend
    node = v_add(v_add(v_sub(start, node), v_mul(v_dir(v_sub(start,center)), extend * v_len(PS))), start);
    return node;
}


void drawSingleTree(TreeNode root){
    int a = 1020;
    //BFT algorithm to draw shape
    strokeWeight(1);
    
    if(root == null)
        System.out.println("Empty tree");
    else{
        //draw branck1
        stroke(20, 200, 250);
        line(center.x, center.y, center.z, 
             root.position.x, root.position.y, root.position.z);
        Queue<TreeNode> q1= new LinkedList<TreeNode>();
        q1.add(root);
        while(q1.peek() != null)
        {
            TreeNode temp = q1.remove();
            //println(temp.position.x);
            if(temp.left != null){
                a--;
                stroke(20,200,250,a/4);
                //println("left line");
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.left.position.x, temp.left.position.y, temp.left.position.z);
                q1.add(temp.left);
            }
            if(temp.right != null){
                stroke(20,100,250,a/4);
                //println("right line");
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.right.position.x, temp.right.position.y, temp.right.position.z);
                q1.add(temp.right); 
            }
        }
        //println("finish draw singel tree");
    }  
}


TreeNode makeSingleTree(int[] dataSet){ //parameter
    //get data ready  
    float[] data = trimDataForShape(dataSet);
    float[] extend = new float[data.length];
    extend[0] = 1;
    for(int i = 1; i<extend.length; i++){
        extend[i] = (float)2*(data[i] - data[i-1])/ (float)data[i-1];
        println(extend[i]);
    }
    
    //make tree  
    PVector[] roots = firstThree(data[0]);
    Cluster shape = new Cluster(roots[0], roots[1], roots[2]);
    
    for(int i = 0; i<data.length; i++){
        TreeNode root = new TreeNode(center);
        root.right = shape.root2; 
        addLayerQ(shape.root1, root, data[i], extend[i]);
        
        //addLayerQ(root, dummyHead, data[i], extend[i]);
    }
    
    println("finish make single tree;");
    
    return shape.root1;
}


void drawSingleTreeGT(TreeNode root){
    int a = 1020;
    int r = 280, g = 510;
    //BFT algorithm to draw shape
    strokeWeight(1);
    
    if(root == null)
        System.out.println("Empty tree");
    else{
        //draw branck1
        stroke(r/2, g/2, 0);
        line(center.x, center.y, center.z, 
             root.position.x, root.position.y, root.position.z);
        Queue<TreeNode> q1= new LinkedList<TreeNode>();
        q1.add(root);
        while(q1.peek() != null)
        {
            TreeNode temp = q1.remove();
            //println(temp.position.x);
            if(temp.left != null){
                a--; r--; g--;
                stroke(r/2,g/2,0,a/4);
                //println("left line");
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.left.position.x, temp.left.position.y, temp.left.position.z);
                q1.add(temp.left);
            }
            if(temp.right != null){
                stroke(r/2,g/2,0,a/4);
                //println("right line");
                line(temp.position.x, temp.position.y, temp.position.z, 
                     temp.right.position.x, temp.right.position.y, temp.right.position.z);
                q1.add(temp.right); 
            }
        }
        //println("finish draw singel tree");
    }  
}






//Doesn't work because using DFT
void addLayer(TreeNode root, TreeNode pNode, float data, float extend){
    if(root != null){
         if(root.left == null){
             println("make new leaves");
             println(root.position.x + "  " + pNode.position.x + " " + pNode.right.position.x );
             root.left = new TreeNode(nextPositive(data, extend, 
                                             root.position, pNode.position, pNode.right.position));
             root.right = new TreeNode(nextNegative(data, extend, 
                                                root.position, pNode.position, pNode.right.position));
         }else{
             addLayer(root.left, root, data, extend);
             addLayer(root.right, root, data, extend);
         }
    } else {
        return;
    }  
}