//Math Functions to support vector calculation
float v_dist(PVector a, PVector b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z) * (a.z - b.z));
}
float v_len(PVector a) {
    return sqrt(a.x * a.x + a.y * a.y + a.z * a.z);
}
PVector v_mul(PVector a, float s) {
    return new PVector(a.x * s, a.y * s, a.z * s);
}
PVector v_cross(PVector a, PVector b) {
    return new PVector(
        a.y * b.z - a.z * b.y,
        a.z * b.x - a.x * b.z,
        a.x * b.y - a.y * b.x
    );
}
PVector v_sub(PVector a, PVector b) {
    return new PVector(a.x - b.x, a.y - b.y, a.z - b.z);
}
PVector v_add(PVector a, PVector b) {
    return new PVector(a.x + b.x, a.y + b.y, a.z + b.z);
}
PVector v_dir(PVector a){
    PVector gg = v_mul(a, 1/v_len(a));
    return new PVector(gg.x, gg.y, gg.z);
  
}


void drawGCPSketch(){
    //GCP
    for(int j = 0; j<GCP.length; j++ ){   
        for(int i = 0; i < GCP[0].marineF.length; i++){
            stroke(200,30,120);
            line(100+13*i, 80*(j+1)-40, 100+13*i, 80*(j+1)-40+sqrt(sqrt(GCP[j].marineF[i])));
            stroke(0, 100, 200);
            line(102+13*i, 80*(j+1)-40, 102+13*i, 80*(j+1)-40+sqrt(sqrt(GCP[j].aquaticP[i])));
            stroke(200, 200, 50);
            line(104+13*i, 80*(j+1)-40, 104+13*i, 80*(j+1)-40+sqrt(sqrt(GCP[j].crustacean[i])));
            stroke(0, 20, 40);
            line(106+13*i, 80*(j+1)-40, 106+13*i, 80*(j+1)-40+sqrt(sqrt(GCP[j].aquaticM[i])));
            stroke(43, 120, 180);
            line(108+13*i, 80*(j+1)-40, 108+13*i, 80*(j+1)-40+sqrt(sqrt(GCP[j].molluscs[i])));
        }   
    }
}

void drawSLSketch(){
    noStroke();
    fill(20,100,250);
    for(int i = 0; i < sL.length; i++){
        for(int j = 0; j < sL[0].seaLevel.length; j++){
          rect(70*j-400, i*300 -600, 20, (sL[i].seaLevel[j]-6850)/2);
          
        }
    }
    fill(100, 180, 10);
    for(int i =0; i < gT.temperature.length; i++){
      rect(70*i-400, -900, 20, gT.temperature[i]*3);      
    }
}